/*Ghassan Fakher
 * section 4
 gkf01*/
package CMPS212.Spring2013.Bdeir.Assignment2.Bank;

import java.util.ArrayList;
import java.util.Arrays;

public class Account {

	private String accountNumber;
	protected float balance;
	protected Transaction[] transaction;
	private int lastTransactionIndex = 0;
	private static int lastAccountNumber = 0;
	
	
	/*Constructor
	 * @param float initial balance
	 */
	public Account(float initialBalance)
	{
		this.balance = initialBalance;
		transaction = new Transaction[100];
		DepositTransaction a = new DepositTransaction(initialBalance, this);
		addTransaction(a);
		lastAccountNumber++;
		accountNumber = lastAccountNumber + "";
	}
	/*method use to add a transaction to the array of transactions
	 * @param Transaction
	 all  the methods in the package can use it*/
	protected void addTransaction(Transaction transaction)
	{
		this.transaction[lastTransactionIndex] = transaction;
		lastTransactionIndex++;
	}
	/*
	 * @return String representing the account number
	 */
	public String getAccountNumber()
	{
		return accountNumber;
	}
	/*
	 * @return float the balance of the account
	 */
	public float getBalance()
	{
		return balance;
	}
	/*
	 * @param float the amount of the deposited money 
	 */
	public void deposit(float amount)
	{
		balance += amount;
		addTransaction(new DepositTransaction(amount, this));
	}
	/*
	 * @param float the amount to be transferred, Account destination Account
	 */
	public void transfer(float amount, Account toAccount)
	{
		addTransaction(new TransferTransaction(amount, this, toAccount));
		balance -= amount;
		toAccount.balance += amount;
		toAccount.addTransaction(new TransferTransaction(amount, this, toAccount));
	}
	/*
	 * @param float the amount to be withdrawn
	 */
	public void withdraw(float amount)
	{
		balance -= amount;
		addTransaction(new CashWithdrawalTransaction(amount, this, "Branch 1"));
	}
	/*
	 * @param int the number of the transaction
	 * @return Transaction of the transaction number
	 */
	public Transaction getTransaction(int transactionNumber)
	{
		return transaction[transactionNumber];
	}
	/*
	 * @param String the transaction ID
	 * @return Transaction of the correesponding ID
	 */
	public Transaction getTransaction(String transactionID)
	{
		return transaction[Integer.parseInt(transactionID)];
	}
	/*
	 * @return String representation of the Account
	 */
	public String toString()
	{
		String s = "Account Number: " + accountNumber + "\n" + "Balance: $" + balance 
				+ "\n" + "Transaction count: " + lastTransactionIndex +  "\n" + "\n" + "Transactions: " + "\n" + "\n" +  printArray(transaction); 
		return s;
	}
	/*
	 * @return the string representation of the transaction array
	 */
	private String printArray(Transaction[] transaction)
	{
		String s = "";
		for(int i = 0; i < lastTransactionIndex; i++)
		{
			s += "*" + this.transaction[i].toString();
			s += "\n" + "\n";
		}
		return s;
	}
}

